{ Show Some Windows }

uses SVGA256,Txt;

type WinType=record
       X,Y,LenX,LenY:integer;
       C:array[1..5] of byte;  { Head,Menu,Body,Box,Title }
     end;
const
  Win:array[1..4] of WinType=(
	(X:15; Y:30; LenX:300;LenY:200;C:(17,19,18,16,64)),
	(X:15; Y:240;LenX:300;LenY:200;C:(21,23,22,20,64)),
	(X:325;Y:30; LenX:300;LenY:200;C:(25,27,26,24,64)),
	(X:325;Y:240;LenX:300;LenY:200;C:(29,31,30,28,64)));

{  SetPal1  }
procedure SetPal1;
const Pal:array[0..47] of byte=(
       0,15,28, 0,20,35, 0,30,50, 0,42,63,
       0,25,10, 0,31,20, 0,45,30, 0,55,35,
       28,15,10, 35,20,20, 50,25,30, 63,35,42,
       25,25,25, 31,31,31, 42,42,42, 55,55,55);
begin
  SetPalette(16,16,Pal);
end;
{  Box1  }
procedure Box1(X,Y,LenX,LenY,C1,C2,N:integer);
var I:integer;
begin
  for I:=0 to N-1 do begin
    Bar(X,Y+I,LenX-I,1,C1);
    Bar(X+I,Y,1,LenY-I,C1);
    Bar(X+I,Y+LenY-1-I,LenX-I,1,C2);
    Bar(X+LenX-1-I,Y+I,1,LenY-I,C2);
  end;
end;
{  Box2  }
procedure Box2(X,Y,LenX,LenY,C1,C2,Med,N:integer);
var I:integer;
begin
  Dec(N);
  Box1(X,Y,LenX,LenY,C1,C2,1);
  Box1(X+N,Y+N,LenX-N shl 1,LenY-N shl 1,C2,C1,1);
  for I:=0 to N-2 do Box(X+1+I,Y+1+I,LenX-2-I shl 1,LenY-2-I shl 1,Med);
end;
{  Button1  }  { Ty=Thin }
procedure Button1(Ty,X,Y,LenX,LenY,C1,C2,C3,C4:integer;Title:string);
var I:integer;
begin
  Box(X,Y,LenX,LenY,0);
  Box1(X+1,Y+1,LenX-2,LenY-2,C1,C3,Ty);
  Bar(X+1+Ty,Y+1+Ty,LenX-2-Ty shl 1,LenY-2-Ty shl 1,C2);
  Print(X+(LenX-GetWidth(Title)) shr 1,Y+(LenY-10) shr 1,C4,Title);
end;
{  Window1  }
procedure Window1(X,Y,LenX,LenY,C1,C2,C3,C4,C5:integer;Title:string);
var I:integer;
begin
  Bar(X,Y,LenX,30,C1);               { Head }
  Bar(X,Y+30,LenX,20,C2);            { Menu }
  Bar(X,Y+50,LenX,LenY-50,C3);       { Body }
  Box(X,Y,LenX,LenY,0);              { Window Box }
  for I:=0 to 3 do                   { Window Frame }
    Box(X+I+1,Y+I+1,LenX-I shl 1-2,LenY-I shl 1-2,C4+3-I);
  Bar(X+1,Y+26,4,1,0);               { Zoom Left,Up }
  Bar(X+26,Y+1,1,4,0);
  Bar(X+LenX-5,Y+26,4,1,0);          { Zoom Right,Up }
  Bar(X+LenX-27,Y+1,1,4,0);
  Bar(X+1,Y+LenY-27,4,1,0);          { Zoom Left,Down }
  Bar(X+26,Y+LenY-5,1,4,0);
  Bar(X+LenX-5,Y+LenY-27,4,1,0);     { Zoom Right,Down }
  Bar(X+LenX-27,Y+LenY-5,1,4,0);
  Box(X+5,Y+5,LenX-10,22,0);         { Head Box }
  Box(X+5,Y+29,LenX-10,22,0);        { Menu Box }
  Box(X+5,Y+53,LenX-10,LenY-58,0);   { Body Box }
  for I:=0 to 1 do begin
    Bar(X+5,Y+I+27,LenX-10,1,C4+3-2*I);  { Head Lines }
    Bar(X+5,Y+51+I,LenX-10,1,C4+3-2*I);  { Menu Lines }
  end;
  Print3A(1,X+(LenX-GetWidth(Title)) shr 1,Y+10,C5,2,1,Title);
  Button1(2,X+5,Y+5,22,22,C2,C3,C1,0,'-');
  Button1(2,X+LenX-48,Y+5,22,22,C2,C3,C1,0,'o');
  Button1(2,X+LenX-27,Y+5,22,22,C2,C3,C1,0,'[]');
end;
{  Screen1  }
procedure Screen1;
var I,J:integer;
    A:array[0..255] of byte;
begin
  Randomize;
  for I:=0 to 255 do A[I]:=29+Random(2);
  for I:=0 to 39 do for J:=0 to 29 do Put(16*I,16*J,16,16,A);
end;
{  Show1  }
procedure Show1(Ty:integer);  { 300x200 }
var X,Y,C1,C2,C3:integer;
begin
  X:=Win[Ty].X; Y:=Win[Ty].Y;
  C1:=Win[Ty].C[1]; C2:=Win[Ty].C[2]; C3:=Win[Ty].C[3];
  Window1(X,Y,300,200,C1,C2,C3,Win[Ty].C[4],Win[Ty].C[5],'A Window');
  Print(X+24,Y+35,0,'File  Window  Help');
  Box2(X+20,Y+65,260,120,C2,C1,C3,3);
  Box2(X+40,Y+80,220,90,C1,C2,C3,2);
  Button1(2,X+165,Y+130,80,26,C2,C3,C1,0,'Exit');
  Box1(X+165-2,Y+130-2,80+4,26+4,C2,C1,1);
end;

var I:integer;
    Font:array[0..5000] of byte;
begin
  SetMode(3);
  FileRead('1212sim#.fnt',0,96,24,Font);
  InstallFont(2,16,12,32,96,1,Font);
  SetPal1;
  Screen1;
  for I:=1 to 4 do Show1(I);
  Readln;
  SetMode(0);
end.
