{ Clock/Window }

uses SVGA256,Txt;

{  Win1  }
procedure Win1(X,Y,LenX,LenY,CBar1,CBar2,CTitle:integer;Title:string);
const B:array[0..3] of byte=(0,15,15,0);  { Outside-->Inside }
var I:integer;
begin
  for I:=0 to 3 do Box(X+I,Y+I,LenX-2*I,LenY-2*I,B[I]);
  Bar(X+4,Y+4,LenX-8,20,CBar1);
  Bar(X+4,Y+24,LenX-8,1,0);
  Bar(X+4,Y+25,LenX-8,LenY-29,CBar2);
  Bar(X+1,Y+24,2,1,0); Bar(X+24,Y+1,1,2,0);
  Bar(X+LenX-24,Y+1,1,2,0); Bar(X+LenX-3,Y+24,2,1,0);
  Bar(X+1,Y+LenY-24,2,1,0); Bar(X+24,Y+LenY-3,1,2,0);
  Bar(X+LenX-24,Y+LenY-3,1,2,0); Bar(X+LenX-3,Y+LenY-24,2,1,0);
  Print(X+(LenX-GetWidth(Title)) shr 1,Y+8,CTitle,Title);
end;
{  Clock  }
procedure Clock(X,Y,LenX,LenY:integer);
var I,A,B,C,D,E,F,Rx,Ry,Cx,Cy:integer;
    R:real;
    St:String;
begin
  Win1(X,Y,LenX,LenY,1,3,15,'Clock/Window');
  Rx:=LenX shr 1-10; Ry:=LenY shr 1-20;
  Cx:=X+LenX shr 1-1; Cy:=Y+LenY shr 1+8;
  for I:=0 to 59 do begin
    R:=I*Pi/30;
    Bar(Trunc(Cos(R)*Rx)+Cx,Trunc(Sin(R)*Ry)+Cy,2,2,0);
    Bar(Trunc(Cos(R)*Rx)+Cx-1,Trunc(Sin(R)*Ry)+Cy-1,2,2,32+I);
  end;
  for I:=0 to 11 do begin
    R:=I*Pi/6;
    Bar(Trunc(Cos(R)*Rx)+Cx,Trunc(Sin(R)*Ry)+Cy,4,4,0);
    Bar(Trunc(Cos(R)*Rx)+Cx-1,Trunc(Sin(R)*Ry)+Cy-1,4,4,32+I);
    Str((I+2) mod 12+1,St);
    Print(Trunc(Cos(R)*(Rx-10))+Cx-2,Trunc(Sin(R)*(Ry-10))+Cy-3,0,St);
    Print(Trunc(Cos(R)*(Rx-10))+Cx-3,Trunc(Sin(R)*(Ry-10))+Cy-4,32+I,St);
  end;
  D:=13; E:=61; F:=61;
  repeat
    St:=GetTime;
    Val(Copy(St,1,2),A,I);
    Val(Copy(St,4,2),B,I);
    Val(Copy(St,7,2),C,I);
    if A<>D then begin
      Bar(Cx-30,Cy+Ry div 3,72,13,3);
      D:=A;
    end;
    if B<>E then begin
      Bar(Cx-20,Cy-Ry div 3-8,72,13,3);
      R:=Pi*((30*D+E/2)/180+1.5);
      Line(Cx,Cy,Trunc(Cos(R)*(Rx-30))+Cx,Trunc(Sin(R)*(Ry-30))+Cy,3);
      R:=Pi*(E/30+1.5);
      Line(Cx,Cy,Trunc(Cos(R)*(Rx-20))+Cx,Trunc(Sin(R)*(Ry-20))+Cy,3);
      E:=B;
    end;
    if C<>F then begin
      Bar(Cx-20+GetWidth(Copy(St,1,6)),Cy-Ry div 3-8,16,13,3);
      R:=Pi*(F/30+1.5);
      Line(Cx,Cy,Trunc(Cos(R)*(Rx-25))+Cx,Trunc(Sin(R)*(Ry-25))+Cy,3);
      Print(Cx-19,Cy-Ry div 3-7,0,Copy(St,1,6));
      Print(Cx-19+GetWidth(Copy(St,1,6)),Cy-Ry div 3-7,0,Copy(St,7,2));
      Print(Cx-29,Cy+Ry div 3+1,0,GetDate);
      Print2(Cx-20,Cy-Ry div 3-8,40,Copy(St,1,6));
      Print2(Cx-20+GetWidth(Copy(St,1,6)),Cy-Ry div 3-8,46,Copy(St,7,2));
      Print2(Cx-30,Cy+Ry div 3,40,GetDate);
      R:=Pi*((30*A+B/2)/180+1.5);
      Line(Cx,Cy,Trunc(Cos(R)*(Rx-35))+Cx,Trunc(Sin(R)*(Ry-35))+Cy,40);
      R:=Pi*(B/30+1.5);
      Line(Cx,Cy,Trunc(Cos(R)*(Rx-20))+Cx,Trunc(Sin(R)*(Ry-20))+Cy,44);
      R:=Pi*(C/30+1.5);
      Line(Cx,Cy,Trunc(Cos(R)*(Rx-25))+Cx,Trunc(Sin(R)*(Ry-25))+Cy,48);
      F:=C;
    end;
  until KeyPressed;
end;

var Font1:array[0..4095] of byte;
begin
  SetMode(3);
  FileRead('1212sim#.fnt',0,96,24,Font1);
  InstallFont(2,16,12,32,96,1,Font1);
  Clock(180,100,280,280);
  SetMode(0);
end.
